#!/bin/bash

. /etc/os-release
VERSION=""
if [ "${VERSION_ID:-}" != "" ]; then
        VERSION="$VERSION_ID"
else
        VERSION=""
fi
if [ $ID == "rhel" ] || [ $ID == "fedora" ] || [ $ID == "rocky" ]; then
V_ID="$(echo "$VERSION" | cut -f1 -d.)"
else
V_ID=${VERSION/./}
fi

ARCH=`arch`
dfile=/tmp/vlan_release
efile=/etc/vlan_release
download_url="https://api.vlan.cn/vlan/getRelease?type=5&model=${ID}_${V_ID}_${ARCH}&kind=1"
wget --no-check-certificate "$download_url" -O $dfile

have_id=$(cat $dfile | grep "id" | wc -l)
if [ $have_id -eq 0 ]; then
        exit
fi

new_version=$(cat $dfile | awk  -F 'id"' '{print $2}' | awk -F '"' '{print $2}' | awk -F '"' '{print $1}')
new_file_url=$(cat $dfile | awk  -F 'location"' '{print $2}' | awk -F ':"' '{print $2}' | awk -F '"' '{print $1}')
new_file=$(echo $new_file_url | awk -F '/' '{print $NF}')
new_dir=$(echo $new_file | awk -F '.tar' '{print $1}')
new_sum=$(cat $dfile | awk  -F 'checksum"' '{print $2}' | awk -F '"' '{printf $2}' | awk -F '"' '{print $1}')
old_version=$(cat $efile | awk -F 'id"' '{print $2}' | awk -F '"' '{print $2}' | awk -F '"' '{print $1}') 2> /dev/null
if [ "$new_version" != "$old_version" ]; then
        cd /tmp && wget $new_file_url
        ns=$(md5sum $new_file | awk '{print $1}')
        if [ $ns == $new_sum ]; then
                tar zxf $new_file
                cd vlan_update && ./update
                cp $dfile /etc
                cd ../ && rm vlan_update -rf
        fi
        rm $new_file -f
fi
rm $dfile -f
